// ----------------------------------------------------
// Notice:
// You may do whatever you want with this code,
// but please keep in mind that I am in no way
// responsible for any damage done to your calculator,
// or whatever (so please don't sue me, uwu)
// ----------------------------------------------------

// Also, the convertion part ought to be the worst one
// imho.
// Reading the source code alone, you could probably
// make your own converter. That's intentional! Now
// go forth, reverse, and make your own reader
// because I'm too lazy to show the dumb, inefficeint
// one written in JS.
#include <gint/display.h>
#include <gint/keyboard.h>
#include <gint/bfile.h>
#include <gint/gint.h>
#include <stdlib.h>
#include <stdint.h>
#include <stddef.h>

#define VID_WIDTH		320
#define VID_HEIGHT		200
#define FRAMES			2192
#define VID_SIZE		(VID_WIDTH * VID_HEIGHT)
#define VID_PATH		u"\\\\fls0\\outba.bin"		// \\fls0\outba.bin
								// or /outba.bin
// Number of shades of gray.
const uint8_t MP = 8;
int main(void) {
	// Open file(read-only)
	int f = gint_world_switch(GINT_CALL(BFile_Open, (void*) VID_PATH, BFile_ReadOnly));	
	if(f >= 0) {
		// Convertion table computed at runtime
		// TODO: Store in ROM!
		uint16_t* convtable = malloc(128 * sizeof(uint16_t));
		for(uint8_t x = 0; x < 128; x++) {
			uint8_t i = x & 0b00000111;
			uint8_t r = (x & 0b01000000) >> 6;
			uint8_t g = (x & 0b00110000) >> 4;
			uint8_t b = (x & 0b00001000) >> 3;

			uint16_t r5 = (int) (((double) (r * i) / (double) MP) * 31.0);
			uint16_t g6 = (int) (((double) ((g + 1) * i) / 4.0 / (double) MP) * 63.0);
			uint16_t b5 = (int) (((double) (b * i) / (double) MP) * 31.0);
			convtable[x] = (r5 << (5 + 6)) | (g6 << (5)) | b5;
		}
		//convtable[127] = 0xFFFF;
		// Allocate a buffer responsible
		// for holding the current compressed frame.
		// We yet doesn't know it's real size,
		// but we do know the worst case scenario is
		// {VID_SIZE}...
		uint8_t* buf = malloc(VID_SIZE);
		// Output buffer.
		// We are 100% sure it will NEVER 
		// exceed the output size.
		uint8_t* obuf = malloc(VID_SIZE);	
		// Output index
		size_t cposo = 0;
		// Input index
		size_t cposi = 0;
		// Current index *in file*
		int pos = 0;

		// Load frames
		for(size_t i = 0; i < FRAMES; i++) {
			// How many bytes do we need to load?
			// Well, really depends on what we really used beforehand
			// which is stored in {cposi}.
			// We can actually just skip {cposi} bytes!
			pos += cposi;
			cposi = 0;

			// NOTE:
			// With Fugue, you can safely
			// read past the end without consequences,
			// but I am not sure with CASIO's inhouse
			// CASIOWIN fs. Anyways, this addin
			// will not even make sense on the monochrome
			// models(which may have CASIOWIN as an fs),
			// as in the video will not fit!
			gint_world_switch(GINT_CALL(BFile_Read, f, (void*) buf, VID_SIZE, pos));
			// We can now uncompress the current frame.
			uint8_t previousc;
			for(cposo = 0; cposo < VID_SIZE;) {
				uint8_t c = buf[cposi++];
				if(!(c & 0x80)) {
					previousc = c;
					obuf[cposo++] = c;
					continue;
				}
				uint32_t repeat = 0;
				switch(c) {
					// Short repeat
					case 0x80:
						repeat = (buf[cposi++] + 4);
						for(uint32_t j = 0; j < repeat; j++) obuf[cposo++] = previousc;
						cposo--;
						break;
					// 'Til end
					case 0x81:
						for(; cposo <= VID_SIZE;) obuf[cposo++] = previousc;
						//cposi++;
						cposo--;
						goto a;
						break;
					// Repeat for an entire line.
					case 0x82:
						for(uint32_t j = 0; j < VID_WIDTH; j++) obuf[cposo++] = previousc;
						break;
					case 0x84:
						repeat = (buf[cposi++] << 8);
						repeat |= buf[cposi++];					
						repeat += 5;	
						//repeat &= 0xFFFFF;
						for(uint32_t j = 0; j < repeat; j++) obuf[cposo++] = previousc;
						cposo--;
				}
			}
a:
			// Now that our frame is uncompressed, display it!
			dclear(C_WHITE);
			for(size_t y = 0; y < VID_HEIGHT; y++) {
				for(size_t x = 0; x < VID_WIDTH; x++) {
					uint8_t c = obuf[y * VID_WIDTH + x];
					// Convert from our weird RGGBIII to
					// RGB565 with our funky table.
					uint16_t c16 = convtable[c];
					dpixel(x, y, c16);
				}
			}
			dprint(1, 1, C_GREEN, "Frame: %lu:%d", i, pos);
			dupdate();
			//getkey();
			//gint_world_switch(GINT_CALL(BFile_Read, f, (void*) buf, (int) cposi, pos));
			//if(i == 0) cposi++;
		}
		gint_world_switch(GINT_CALL(BFile_Close, f));	
		return 1;
	}
	dclear(C_WHITE);
	dtext(1, 1 , C_BLACK, "Video file couldn't be opened...");
	dtext(1, 11, C_BLACK, "Maybe it doesn't exist?");
	dupdate();
	getkey();
	return 1;
}
